require 'active_support/inflector'
require 'singleton'
require 'sinatra/base'
require 'sinatra/multi_route'

require_relative 'model'

# Sinatra based web server.
# Turns your sequel model directly into a RESTful API.
module Resta

  module_function
  def get_model_pluralize_name(m)
    m.name.split(':').last.underscore.pluralize.to_sym
  end

  # Global singleton hash object for storing resource builder object.
  class RestaStore < Hash
    include Singleton
  end

  # Resta resource object builder class
  class ResourceBuilder

    # Current support restful methods for resta.
    ALLOWED_METODS = [:update, :create, :delete, :get, :query, :patch].freeze
  end
end

module Sinatra

  # Resta related helpers for sinatra
  module RestaHelpers

  end
  helpers RestaHelpers

  class << Application
    def resource(model, opts = {}, &block)

    end
  end
  Delegator.delegate(:resource)

end
